'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _rax = require('rax');

var _raxView = require('rax-view');

var _raxView2 = _interopRequireDefault(_raxView);

var _raxText = require('rax-text');

var _raxText2 = _interopRequireDefault(_raxText);

var _raxTouchable = require('rax-touchable');

var _raxTouchable2 = _interopRequireDefault(_raxTouchable);

var _Day = require('./Day');

var _Day2 = _interopRequireDefault(_Day);

var _moment = require('./moment');

var _moment2 = _interopRequireDefault(_moment);

var _styles = require('./styles');

var _styles2 = _interopRequireDefault(_styles);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var DEVICE_WIDTH = 750;
var VIEW_INDEX = 2;

var Calendar = function (_Component) {
  _inherits(Calendar, _Component);

  function Calendar() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Calendar);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Calendar.__proto__ || Object.getPrototypeOf(Calendar)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      currentMonthMoment: (0, _moment2.default)(_this.props.selectedDate || _this.props.startDate || _this.props.endDate || _this.props.today),
      selectedMoment: (0, _moment2.default)(_this.props.selectedDate)
    }, _this.onPrev = function () {
      var newMoment = (0, _moment2.default)(_this.state.currentMonthMoment).addMonth(-1);
      _this.setState({ currentMonthMoment: newMoment });
      _this.props.onTouchPrev && _this.props.onTouchPrev(newMoment);
    }, _this.onNext = function () {
      var newMoment = (0, _moment2.default)(_this.state.currentMonthMoment).addMonth(1);
      _this.setState({ currentMonthMoment: newMoment });
      _this.props.onTouchNext && _this.props.onTouchNext(newMoment);
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Calendar, [{
    key: 'getMonthStack',
    value: function getMonthStack(currentMonth) {
      return [(0, _moment2.default)(currentMonth)];
    }
  }, {
    key: 'prepareEventDates',
    value: function prepareEventDates(eventDates) {
      var parsedDates = {};

      eventDates.forEach(function (event) {
        var date = (0, _moment2.default)(event);
        var month = (0, _moment2.default)(date).startOfMonth().format();
        if (!parsedDates[month]) {
          parsedDates[month] = {};
        }
        parsedDates[month][date.date() - 1] = true;
      });
      return parsedDates;
    }
  }, {
    key: 'selectDate',
    value: function selectDate(date) {
      this.setState({ selectedMoment: date });
      this.props.onDateSelect && this.props.onDateSelect(date.format(this.props.dateFormat));
    }
  }, {
    key: 'renderMonthView',
    value: function renderMonthView(argMoment, eventDatesMap) {
      var _this2 = this;

      var renderIndex = 0,
          weekRows = [],
          days = [],
          startOfArgMonthMoment = argMoment.startOfMonth();

      var selectedMoment = (0, _moment2.default)(this.state.selectedMoment),
          weekStart = this.props.weekStart,
          todayMoment = (0, _moment2.default)(this.props.today),
          todayIndex = todayMoment.date() - 1,
          argMonthDaysCount = argMoment.daysInMonth(),
          offset = (startOfArgMonthMoment.isoWeekday() - weekStart + 7) % 7,
          argMonthIsToday = argMoment.isSameMonth(todayMoment),
          selectedIndex = (0, _moment2.default)(selectedMoment).date() - 1,
          selectedMonthIsArg = selectedMoment.isSameMonth(argMoment),
          startMoment = this.props.startDate && (0, _moment2.default)(this.props.startDate),
          endMoment = this.props.endDate && (0, _moment2.default)(this.props.endDate);

      var events = eventDatesMap !== null ? eventDatesMap[argMoment.startOfMonth().format()] : null;

      if (!argMoment.isValid()) {
        console.error('[currentMonthMoment] is not valid, make sure [selectedDate startDate endDate today] are valid date');
        return null;
      }

      var _loop = function _loop() {
        var dayIndex = renderIndex - offset;
        var isoWeekday = (renderIndex + weekStart) % 7;
        var date = (0, _moment2.default)(startOfArgMonthMoment).setDate(dayIndex + 1);
        var isDisabled = startMoment && date.getTime() < startMoment.getTime() || endMoment && date.getTime() > endMoment.getTime();

        if (dayIndex >= 0 && dayIndex < argMonthDaysCount) {
          days.push((0, _rax.createElement)(_Day2.default, {
            startOfMonth: startOfArgMonthMoment,
            isWeekend: isoWeekday === 0 || isoWeekday === 6,
            key: '' + renderIndex,
            onPress: function onPress() {
              _this2.selectDate(date);
            },
            caption: '' + (dayIndex + 1),
            isToday: argMonthIsToday && dayIndex === todayIndex,
            isSelected: selectedMonthIsArg && dayIndex === selectedIndex,
            hasEvent: events && events[dayIndex] === true,
            usingEvents: _this2.props.eventDates.length > 0,
            customStyle: _this2.props.customStyle,
            isDisabled: isDisabled
          }));
        } else {
          days.push((0, _rax.createElement)(_Day2.default, { key: '' + renderIndex, filler: true }));
        }
        if (renderIndex % 7 === 6) {
          weekRows.push((0, _rax.createElement)(
            _raxView2.default,
            {
              key: weekRows.length,
              style: [_styles2.default.weekRow, _this2.props.customStyle.weekRow]
            },
            days
          ));
          days = [];
          if (dayIndex + 1 >= argMonthDaysCount) {
            return 'break';
          }
        }
        renderIndex += 1;
      };

      do {
        var _ret2 = _loop();

        if (_ret2 === 'break') break;
      } while (true);

      return (0, _rax.createElement)(
        _raxView2.default,
        { key: argMoment.month(), style: _styles2.default.monthContainer },
        weekRows
      );
    }
  }, {
    key: 'renderHeading',
    value: function renderHeading() {
      var headings = [];
      for (var i = 0; i < 7; i++) {
        var j = (i + this.props.weekStart) % 7;
        headings.push((0, _rax.createElement)(
          _raxText2.default,
          {
            key: i,
            style: j === 0 || j === 6 ? [_styles2.default.weekendHeading, this.props.customStyle.weekendHeading] : [_styles2.default.dayHeading, this.props.customStyle.dayHeading]
          },
          this.props.dayHeadings[j]
        ));
      }

      return (0, _rax.createElement)(
        _raxView2.default,
        { style: [_styles2.default.calendarHeading, this.props.customStyle.calendarHeading] },
        headings
      );
    }
  }, {
    key: 'renderTopBar',
    value: function renderTopBar() {
      return this.props.showControls ? (0, _rax.createElement)(
        _raxView2.default,
        { style: [_styles2.default.calendarControls, this.props.customStyle.calendarControls] },
        (0, _rax.createElement)(
          _raxTouchable2.default,
          {
            style: [_styles2.default.controlButton, this.props.customStyle.controlButton],
            onPress: this.onPrev
          },
          (0, _rax.createElement)(
            _raxText2.default,
            { style: [_styles2.default.controlButtonText, this.props.customStyle.controlButtonText] },
            this.props.prevButtonText
          )
        ),
        (0, _rax.createElement)(
          _raxText2.default,
          { style: [_styles2.default.title, this.props.customStyle.title] },
          this.state.currentMonthMoment.format(this.props.titleFormat)
        ),
        (0, _rax.createElement)(
          _raxTouchable2.default,
          {
            style: [_styles2.default.controlButton, this.props.customStyle.controlButton],
            onPress: this.onNext
          },
          (0, _rax.createElement)(
            _raxText2.default,
            { style: [_styles2.default.controlButtonText, this.props.customStyle.controlButtonText] },
            this.props.nextButtonText
          )
        )
      ) : (0, _rax.createElement)(
        _raxView2.default,
        { style: [_styles2.default.calendarControls, this.props.customStyle.calendarControls] },
        (0, _rax.createElement)(
          _raxText2.default,
          { style: [_styles2.default.title, this.props.customStyle.title] },
          this.state.currentMonthMoment.format(this.props.titleFormat)
        )
      );
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      var calendarDates = this.getMonthStack(this.state.currentMonthMoment);
      var eventDatesMap = this.prepareEventDates(this.props.eventDates);
      var calendarDatesNode = calendarDates.map(function (date) {
        return _this3.renderMonthView((0, _moment2.default)(date), eventDatesMap);
      });
      return (0, _rax.createElement)(
        _raxView2.default,
        { style: [_styles2.default.calendarContainer, this.props.customStyle.calendarContainer] },
        this.renderTopBar(),
        this.props.showDayHeadings && this.renderHeading(this.props.titleFormat),
        (0, _rax.createElement)(
          _raxView2.default,
          { style: { height: calendarDatesNode[0].props.children.length * 92 } },
          calendarDatesNode
        )
      );
    }
  }]);

  return Calendar;
}(_rax.Component);

Calendar.propTypes = {
  customStyle: _rax.PropTypes.object,
  dayHeadings: _rax.PropTypes.array,
  eventDates: _rax.PropTypes.array,
  monthNames: _rax.PropTypes.array,
  nextButtonText: _rax.PropTypes.string,
  onDateSelect: _rax.PropTypes.func,
  onSwipeNext: _rax.PropTypes.func,
  onSwipePrev: _rax.PropTypes.func,
  onTouchNext: _rax.PropTypes.func,
  onTouchPrev: _rax.PropTypes.func,
  prevButtonText: _rax.PropTypes.string,
  selectedDate: _rax.PropTypes.any,
  showControls: _rax.PropTypes.bool,
  startDate: _rax.PropTypes.any,
  endDate: _rax.PropTypes.any,
  titleFormat: _rax.PropTypes.string,
  dateFormat: _rax.PropTypes.string,
  today: _rax.PropTypes.any,
  weekStart: _rax.PropTypes.number
};
Calendar.defaultProps = {
  customStyle: {},
  dayHeadings: ['S', 'M', 'T', 'W', 'T', 'F', 'S'],
  eventDates: [],
  monthNames: ['Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec'],
  nextButtonText: 'Next',
  prevButtonText: 'Prev',
  showControls: true,
  titleFormat: 'MMMM YYYY',
  dateFormat: 'YYYY-MM-DD',
  today: (0, _moment2.default)(),
  weekStart: 1
};
exports.default = Calendar;
module.exports = exports['default'];